/*
 * Copyright 2023 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Pins v15.0
processor: MCXA153
package_id: MCXA153VLH
mcu_data: ksdk2_0
processor_version: 0.15.5
board: FRDM-MCXA153
external_user_signals: {}
pin_labels:
- {pin_num: '15', pin_signal: P2_1/TRIG_IN7/LPUART0_TXD/CT_INP17/CT2_MAT1/ADC0_A1, label: 'P2_1/J2[7]', identifier: VOLT_DCB}
- {pin_num: '17', pin_signal: P2_3/WUU0_IN19/TRIG_IN7/LPUART0_CTS_B/LPUART2_RXD/CT_INP13/CT2_MAT3/ADC0_A2/CMP1_IN0, label: 'P2_3/J2[5]', identifier: CUR_C}
- {pin_num: '39', pin_signal: P3_11/WUU0_IN24/TRIG_IN6/LPSPI1_PCS0/LPUART1_CTS_B/CT1_MAT1/PWM0_B2, label: 'P3_11/J3[5]', identifier: PWM_CB}
- {pin_num: '40', pin_signal: P3_10/TRIG_IN5/LPSPI1_SCK/LPUART1_RTS_B/CT1_MAT0/PWM0_A2, label: 'P3_10/J3[7]', identifier: PWM_CT}
- {pin_num: '41', pin_signal: P3_9/TRIG_IN4/LPSPI1_SDI/LPUART1_TXD/CT_INP5/PWM0_B1, label: 'P3_9/J3[9]', identifier: PWM_BB}
- {pin_num: '42', pin_signal: P3_8/WUU0_IN23/TRIG_IN3/LPSPI1_SDO/LPUART1_RXD/CT_INP4/PWM0_A1/CLKOUT, label: 'P3_8/J3[11]', identifier: PWM_BT}
- {pin_num: '43', pin_signal: P3_7/TRIG_IN2/LPSPI1_PCS2/PWM0_B0, label: 'P3_7/J3[13]', identifier: PWM_AB}
- {pin_num: '44', pin_signal: P3_6/CLKOUT/LPSPI1_PCS3/PWM0_A0/FREQME_CLK_OUT1, label: 'P3_6/J3[15]', identifier: PWM_AT}
- {pin_num: '62', pin_signal: P1_4/WUU0_IN8/FREQME_CLK_IN0/LPSPI0_PCS3/LPUART2_RXD/CT1_MAT2/ADC0_A20/CMP0_IN2, label: 'P1_4/J2[1]/J1[2]', identifier: CUR_A}
- {pin_num: '63', pin_signal: P1_5/FREQME_CLK_IN1/LPSPI0_PCS2/LPUART2_TXD/CT1_MAT3/ADC0_A21/CMP1_IN2, label: 'P1_5/J2[3]/J1[4]', identifier: CUR_B}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

#include "fsl_common.h"
#include "fsl_port.h"
#include "fsl_gpio.h"
#include "fsl_inputmux.h"
#include "pin_mux.h"

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitBootPins
 * Description   : Calls initialization functions.
 *
 * END ****************************************************************************************************************/
void BOARD_InitBootPins(void)
{
    BOARD_InitUARTPins();
    BOARD_InitLEDsPins();
    BOARD_InitBUTTONsPins();
    BOARD_InitPWM();
    BOARD_InitADC();
    BOARD_InitENC();
    BOARD_InitCMP();
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitUARTPins:
- options: {callFromInitBoot: 'true', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '51', peripheral: LPUART0, signal: RX, pin_signal: P0_2/TDO/SWO/LPUART0_RXD/LPSPI0_SCK/CT0_MAT0/UTICK_CAP0/I3C0_PUR, slew_rate: fast, open_drain: disable,
    drive_strength: high, pull_select: down, pull_enable: disable, input_buffer: enable, invert_input: normal}
  - {pin_num: '52', peripheral: LPUART0, signal: TX, pin_signal: P0_3/TDI/LPUART0_TXD/LPSPI0_SDO/CT0_MAT1/UTICK_CAP1/CMP0_OUT/CMP1_IN1, slew_rate: fast, open_drain: disable,
    drive_strength: low, pull_select: up, pull_enable: enable, input_buffer: enable, invert_input: normal}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitUARTPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitUARTPins(void)
{
    /* Write to PORT0: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT0);
    /* LPUART0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kLPUART0_RST_SHIFT_RSTn);
    /* PORT0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT0_RST_SHIFT_RSTn);

    const port_pin_config_t DEBUG_UART_RX = {/* Internal pull-up/down resistor is disabled */
                                             kPORT_PullDisable,
                                             /* Low internal pull resistor value is selected. */
                                             kPORT_LowPullResistor,
                                             /* Fast slew rate is configured */
                                             kPORT_FastSlewRate,
                                             /* Passive input filter is disabled */
                                             kPORT_PassiveFilterDisable,
                                             /* Open drain output is disabled */
                                             kPORT_OpenDrainDisable,
                                             /* High drive strength is configured */
                                             kPORT_HighDriveStrength,
                                             /* Normal drive strength is configured */
                                             kPORT_NormalDriveStrength,
                                             /* Pin is configured as LPUART0_RXD */
                                             kPORT_MuxAlt2,
                                             /* Digital input enabled */
                                             kPORT_InputBufferEnable,
                                             /* Digital input is not inverted */
                                             kPORT_InputNormal,
                                             /* Pin Control Register fields [15:0] are not locked */
                                             kPORT_UnlockRegister};
    /* PORT0_2 (pin 51) is configured as LPUART0_RXD */
    PORT_SetPinConfig(BOARD_INITUARTPINS_DEBUG_UART_RX_PORT, BOARD_INITUARTPINS_DEBUG_UART_RX_PIN, &DEBUG_UART_RX);

    const port_pin_config_t DEBUG_UART_TX = {/* Internal pull-up resistor is enabled */
                                             kPORT_PullUp,
                                             /* Low internal pull resistor value is selected. */
                                             kPORT_LowPullResistor,
                                             /* Fast slew rate is configured */
                                             kPORT_FastSlewRate,
                                             /* Passive input filter is disabled */
                                             kPORT_PassiveFilterDisable,
                                             /* Open drain output is disabled */
                                             kPORT_OpenDrainDisable,
                                             /* Low drive strength is configured */
                                             kPORT_LowDriveStrength,
                                             /* Normal drive strength is configured */
                                             kPORT_NormalDriveStrength,
                                             /* Pin is configured as LPUART0_TXD */
                                             kPORT_MuxAlt2,
                                             /* Digital input enabled */
                                             kPORT_InputBufferEnable,
                                             /* Digital input is not inverted */
                                             kPORT_InputNormal,
                                             /* Pin Control Register fields [15:0] are not locked */
                                             kPORT_UnlockRegister};
    /* PORT0_3 (pin 52) is configured as LPUART0_TXD */
    PORT_SetPinConfig(BOARD_INITUARTPINS_DEBUG_UART_TX_PORT, BOARD_INITUARTPINS_DEBUG_UART_TX_PIN, &DEBUG_UART_TX);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitSWD_DEBUGPins:
- options: {callFromInitBoot: 'false', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '50', peripheral: SWD, signal: SWCLK, pin_signal: P0_1/TCLK/SWCLK/LPUART0_CTS_B/LPSPI0_SDI/CT_INP1, slew_rate: fast, open_drain: disable, drive_strength: low,
    pull_select: down, pull_enable: enable, input_buffer: enable, invert_input: normal}
  - {pin_num: '49', peripheral: SWD, signal: SWDIO, pin_signal: P0_0/TMS/SWDIO/LPUART0_RTS_B/LPSPI0_PCS0/CT_INP0, slew_rate: fast, open_drain: disable, drive_strength: high,
    pull_select: up, pull_enable: enable, input_buffer: enable, invert_input: normal}
  - {pin_num: '51', peripheral: SWD, signal: SWO, pin_signal: P0_2/TDO/SWO/LPUART0_RXD/LPSPI0_SCK/CT0_MAT0/UTICK_CAP0/I3C0_PUR, slew_rate: fast, open_drain: disable,
    drive_strength: high, pull_select: down, pull_enable: disable, input_buffer: enable, invert_input: normal}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitSWD_DEBUGPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitSWD_DEBUGPins(void)
{
    /* Write to PORT0: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT0);
    /* PORT0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT0_RST_SHIFT_RSTn);
    /* LPUART0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kLPUART0_RST_SHIFT_RSTn);

    const port_pin_config_t DEBUG_SWD_SWDIO = {/* Internal pull-up resistor is enabled */
                                               kPORT_PullUp,
                                               /* Low internal pull resistor value is selected. */
                                               kPORT_LowPullResistor,
                                               /* Fast slew rate is configured */
                                               kPORT_FastSlewRate,
                                               /* Passive input filter is disabled */
                                               kPORT_PassiveFilterDisable,
                                               /* Open drain output is disabled */
                                               kPORT_OpenDrainDisable,
                                               /* High drive strength is configured */
                                               kPORT_HighDriveStrength,
                                               /* Normal drive strength is configured */
                                               kPORT_NormalDriveStrength,
                                               /* Pin is configured as SWDIO */
                                               kPORT_MuxAlt1,
                                               /* Digital input enabled */
                                               kPORT_InputBufferEnable,
                                               /* Digital input is not inverted */
                                               kPORT_InputNormal,
                                               /* Pin Control Register fields [15:0] are not locked */
                                               kPORT_UnlockRegister};
    /* PORT0_0 (pin 49) is configured as SWDIO */
    PORT_SetPinConfig(BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PORT, BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PIN, &DEBUG_SWD_SWDIO);

    const port_pin_config_t DEBUG_SWD_SWDCLK = {/* Internal pull-down resistor is enabled */
                                                kPORT_PullDown,
                                                /* Low internal pull resistor value is selected. */
                                                kPORT_LowPullResistor,
                                                /* Fast slew rate is configured */
                                                kPORT_FastSlewRate,
                                                /* Passive input filter is disabled */
                                                kPORT_PassiveFilterDisable,
                                                /* Open drain output is disabled */
                                                kPORT_OpenDrainDisable,
                                                /* Low drive strength is configured */
                                                kPORT_LowDriveStrength,
                                                /* Normal drive strength is configured */
                                                kPORT_NormalDriveStrength,
                                                /* Pin is configured as SWCLK */
                                                kPORT_MuxAlt1,
                                                /* Digital input enabled */
                                                kPORT_InputBufferEnable,
                                                /* Digital input is not inverted */
                                                kPORT_InputNormal,
                                                /* Pin Control Register fields [15:0] are not locked */
                                                kPORT_UnlockRegister};
    /* PORT0_1 (pin 50) is configured as SWCLK */
    PORT_SetPinConfig(BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDCLK_PORT, BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDCLK_PIN, &DEBUG_SWD_SWDCLK);

    const port_pin_config_t DEBUG_UART_RX = {/* Internal pull-up/down resistor is disabled */
                                             kPORT_PullDisable,
                                             /* Low internal pull resistor value is selected. */
                                             kPORT_LowPullResistor,
                                             /* Fast slew rate is configured */
                                             kPORT_FastSlewRate,
                                             /* Passive input filter is disabled */
                                             kPORT_PassiveFilterDisable,
                                             /* Open drain output is disabled */
                                             kPORT_OpenDrainDisable,
                                             /* High drive strength is configured */
                                             kPORT_HighDriveStrength,
                                             /* Normal drive strength is configured */
                                             kPORT_NormalDriveStrength,
                                             /* Pin is configured as SWO */
                                             kPORT_MuxAlt1,
                                             /* Digital input enabled */
                                             kPORT_InputBufferEnable,
                                             /* Digital input is not inverted */
                                             kPORT_InputNormal,
                                             /* Pin Control Register fields [15:0] are not locked */
                                             kPORT_UnlockRegister};
    /* PORT0_2 (pin 51) is configured as SWO */
    PORT_SetPinConfig(BOARD_INITSWD_DEBUGPINS_DEBUG_UART_RX_PORT, BOARD_INITSWD_DEBUGPINS_DEBUG_UART_RX_PIN, &DEBUG_UART_RX);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitLEDsPins:
- options: {callFromInitBoot: 'true', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '37', peripheral: GPIO3, signal: 'GPIO, 13', pin_signal: P3_13/LPUART2_CTS_B/CT1_MAT3/PWM0_X1, direction: OUTPUT, gpio_init_state: 'false', slew_rate: fast,
    open_drain: disable, drive_strength: low, pull_select: down, pull_enable: disable, input_buffer: enable, invert_input: normal}
  - {pin_num: '38', peripheral: GPIO3, signal: 'GPIO, 12', pin_signal: P3_12/LPUART2_RTS_B/CT1_MAT2/PWM0_X0, direction: OUTPUT, gpio_init_state: 'false', slew_rate: fast,
    open_drain: disable, drive_strength: low, pull_select: down, pull_enable: disable, input_buffer: enable, invert_input: normal}
  - {pin_num: '46', peripheral: GPIO3, signal: 'GPIO, 0', pin_signal: P3_0/WUU0_IN22/TRIG_IN0/CT_INP16/PWM0_A0, direction: OUTPUT, gpio_init_state: 'false', slew_rate: fast,
    open_drain: disable, drive_strength: low, pull_select: down, pull_enable: disable, passive_filter: disable, input_buffer: enable, invert_input: normal}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitLEDsPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitLEDsPins(void)
{
    /* Write to GPIO3: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GateGPIO3);
    /* Write to PORT3: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT3);
    /* GPIO3 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kGPIO3_RST_SHIFT_RSTn);
    /* PORT3 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT3_RST_SHIFT_RSTn);

    gpio_pin_config_t LED_BLUE_config = {
        .pinDirection = kGPIO_DigitalOutput,
        .outputLogic = 0U
    };
    /* Initialize GPIO functionality on pin PIO3_0 (pin 46)  */
    GPIO_PinInit(BOARD_INITLEDSPINS_LED_BLUE_GPIO, BOARD_INITLEDSPINS_LED_BLUE_PIN, &LED_BLUE_config);

    gpio_pin_config_t LED_RED_config = {
        .pinDirection = kGPIO_DigitalOutput,
        .outputLogic = 0U
    };
    /* Initialize GPIO functionality on pin PIO3_12 (pin 38)  */
    GPIO_PinInit(BOARD_INITLEDSPINS_LED_RED_GPIO, BOARD_INITLEDSPINS_LED_RED_PIN, &LED_RED_config);

    gpio_pin_config_t LED_GREEN_config = {
        .pinDirection = kGPIO_DigitalOutput,
        .outputLogic = 0U
    };
    /* Initialize GPIO functionality on pin PIO3_13 (pin 37)  */
    GPIO_PinInit(BOARD_INITLEDSPINS_LED_GREEN_GPIO, BOARD_INITLEDSPINS_LED_GREEN_PIN, &LED_GREEN_config);

    /* PORT3_0 (pin 46) is configured as P3_0 */
    PORT_SetPinMux(BOARD_INITLEDSPINS_LED_BLUE_PORT, BOARD_INITLEDSPINS_LED_BLUE_PIN, kPORT_MuxAlt0);

    PORT3->PCR[0] =
        ((PORT3->PCR[0] &
          /* Mask bits to zero which are setting */
          (~(PORT_PCR_PS_MASK | PORT_PCR_PE_MASK | PORT_PCR_SRE_MASK | PORT_PCR_PFE_MASK | PORT_PCR_ODE_MASK | PORT_PCR_DSE_MASK | PORT_PCR_IBE_MASK | PORT_PCR_INV_MASK)))

         /* Pull Select: Enables internal pulldown resistor. */
         | PORT_PCR_PS(PCR_PS_ps0)

         /* Pull Enable: Disables. */
         | PORT_PCR_PE(PCR_PE_pe0)

         /* Slew Rate Enable: Fast. */
         | PORT_PCR_SRE(PCR_SRE_sre0)

         /* Passive Filter Enable: Disables. */
         | PORT_PCR_PFE(PCR_PFE_pfe0)

         /* Open Drain Enable: Disables. */
         | PORT_PCR_ODE(PCR_ODE_ode0)

         /* Drive Strength Enable: Low. */
         | PORT_PCR_DSE(PCR_DSE_dse0)

         /* Input Buffer Enable: Enables. */
         | PORT_PCR_IBE(PCR_IBE_ibe1)

         /* Invert Input: Does not invert. */
         | PORT_PCR_INV(PCR_INV_inv0));

    const port_pin_config_t LED_RED = {/* Internal pull-up/down resistor is disabled */
                                       kPORT_PullDisable,
                                       /* Low internal pull resistor value is selected. */
                                       kPORT_LowPullResistor,
                                       /* Fast slew rate is configured */
                                       kPORT_FastSlewRate,
                                       /* Passive input filter is disabled */
                                       kPORT_PassiveFilterDisable,
                                       /* Open drain output is disabled */
                                       kPORT_OpenDrainDisable,
                                       /* Low drive strength is configured */
                                       kPORT_LowDriveStrength,
                                       /* Normal drive strength is configured */
                                       kPORT_NormalDriveStrength,
                                       /* Pin is configured as P3_12 */
                                       kPORT_MuxAlt0,
                                       /* Digital input enabled */
                                       kPORT_InputBufferEnable,
                                       /* Digital input is not inverted */
                                       kPORT_InputNormal,
                                       /* Pin Control Register fields [15:0] are not locked */
                                       kPORT_UnlockRegister};
    /* PORT3_12 (pin 38) is configured as P3_12 */
    PORT_SetPinConfig(BOARD_INITLEDSPINS_LED_RED_PORT, BOARD_INITLEDSPINS_LED_RED_PIN, &LED_RED);

    const port_pin_config_t LED_GREEN = {/* Internal pull-up/down resistor is disabled */
                                         kPORT_PullDisable,
                                         /* Low internal pull resistor value is selected. */
                                         kPORT_LowPullResistor,
                                         /* Fast slew rate is configured */
                                         kPORT_FastSlewRate,
                                         /* Passive input filter is disabled */
                                         kPORT_PassiveFilterDisable,
                                         /* Open drain output is disabled */
                                         kPORT_OpenDrainDisable,
                                         /* Low drive strength is configured */
                                         kPORT_LowDriveStrength,
                                         /* Normal drive strength is configured */
                                         kPORT_NormalDriveStrength,
                                         /* Pin is configured as P3_13 */
                                         kPORT_MuxAlt0,
                                         /* Digital input enabled */
                                         kPORT_InputBufferEnable,
                                         /* Digital input is not inverted */
                                         kPORT_InputNormal,
                                         /* Pin Control Register fields [15:0] are not locked */
                                         kPORT_UnlockRegister};
    /* PORT3_13 (pin 37) is configured as P3_13 */
    PORT_SetPinConfig(BOARD_INITLEDSPINS_LED_GREEN_PORT, BOARD_INITLEDSPINS_LED_GREEN_PIN, &LED_GREEN);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitBUTTONsPins:
- options: {callFromInitBoot: 'true', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '1', peripheral: GPIO1, signal: 'GPIO, 7', pin_signal: P1_7/WUU0_IN9/TRIG_OUT2/LPUART2_CTS_B/CT_INP7/ADC0_A23, slew_rate: fast, open_drain: disable,
    drive_strength: low, pull_select: down, pull_enable: disable, input_buffer: enable, invert_input: normal}
  - {pin_num: '8', peripheral: GPIO1, signal: 'GPIO, 29', pin_signal: P1_29/RESET_B/SPC_LPREQ, slew_rate: fast, open_drain: enable, drive_strength: low, pull_select: up,
    pull_enable: enable, passive_filter: enable, pull_value: low, input_buffer: enable, invert_input: normal}
  - {pin_num: '32', peripheral: GPIO3, signal: 'GPIO, 29', pin_signal: P3_29/WUU0_IN27/ISPMODE_N/CT_INP3/ADC0_A14, slew_rate: fast, open_drain: disable, drive_strength: low,
    pull_select: up, pull_enable: enable, input_buffer: enable, invert_input: normal}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitBUTTONsPins
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitBUTTONsPins(void)
{
    /* Write to PORT1: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT1);
    /* Write to PORT3: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT3);
    /* GPIO1 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kGPIO1_RST_SHIFT_RSTn);
    /* PORT1 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT1_RST_SHIFT_RSTn);
    /* GPIO3 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kGPIO3_RST_SHIFT_RSTn);
    /* PORT3 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT3_RST_SHIFT_RSTn);

    const port_pin_config_t SW1 = {/* Internal pull-up resistor is enabled */
                                   kPORT_PullUp,
                                   /* Low internal pull resistor value is selected. */
                                   kPORT_LowPullResistor,
                                   /* Fast slew rate is configured */
                                   kPORT_FastSlewRate,
                                   /* Passive input filter is enabled */
                                   kPORT_PassiveFilterEnable,
                                   /* Open drain output is enabled */
                                   kPORT_OpenDrainEnable,
                                   /* Low drive strength is configured */
                                   kPORT_LowDriveStrength,
                                   /* Normal drive strength is configured */
                                   kPORT_NormalDriveStrength,
                                   /* Pin is configured as P1_29 */
                                   kPORT_MuxAlt0,
                                   /* Digital input enabled */
                                   kPORT_InputBufferEnable,
                                   /* Digital input is not inverted */
                                   kPORT_InputNormal,
                                   /* Pin Control Register fields [15:0] are not locked */
                                   kPORT_UnlockRegister};
    /* PORT1_29 (pin 8) is configured as P1_29 */
    PORT_SetPinConfig(BOARD_INITBUTTONSPINS_SW1_PORT, BOARD_INITBUTTONSPINS_SW1_PIN, &SW1);

    const port_pin_config_t SW3 = {/* Internal pull-up/down resistor is disabled */
                                   kPORT_PullDisable,
                                   /* Low internal pull resistor value is selected. */
                                   kPORT_LowPullResistor,
                                   /* Fast slew rate is configured */
                                   kPORT_FastSlewRate,
                                   /* Passive input filter is disabled */
                                   kPORT_PassiveFilterDisable,
                                   /* Open drain output is disabled */
                                   kPORT_OpenDrainDisable,
                                   /* Low drive strength is configured */
                                   kPORT_LowDriveStrength,
                                   /* Normal drive strength is configured */
                                   kPORT_NormalDriveStrength,
                                   /* Pin is configured as P1_7 */
                                   kPORT_MuxAlt0,
                                   /* Digital input enabled */
                                   kPORT_InputBufferEnable,
                                   /* Digital input is not inverted */
                                   kPORT_InputNormal,
                                   /* Pin Control Register fields [15:0] are not locked */
                                   kPORT_UnlockRegister};
    /* PORT1_7 (pin 1) is configured as P1_7 */
    PORT_SetPinConfig(BOARD_INITBUTTONSPINS_SW3_PORT, BOARD_INITBUTTONSPINS_SW3_PIN, &SW3);

    const port_pin_config_t ISP = {/* Internal pull-up resistor is enabled */
                                   kPORT_PullUp,
                                   /* Low internal pull resistor value is selected. */
                                   kPORT_LowPullResistor,
                                   /* Fast slew rate is configured */
                                   kPORT_FastSlewRate,
                                   /* Passive input filter is disabled */
                                   kPORT_PassiveFilterDisable,
                                   /* Open drain output is disabled */
                                   kPORT_OpenDrainDisable,
                                   /* Low drive strength is configured */
                                   kPORT_LowDriveStrength,
                                   /* Normal drive strength is configured */
                                   kPORT_NormalDriveStrength,
                                   /* Pin is configured as P3_29 */
                                   kPORT_MuxAlt0,
                                   /* Digital input enabled */
                                   kPORT_InputBufferEnable,
                                   /* Digital input is not inverted */
                                   kPORT_InputNormal,
                                   /* Pin Control Register fields [15:0] are not locked */
                                   kPORT_UnlockRegister};
    /* PORT3_29 (pin 32) is configured as P3_29 */
    PORT_SetPinConfig(BOARD_INITBUTTONSPINS_ISP_PORT, BOARD_INITBUTTONSPINS_ISP_PIN, &ISP);
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitPWM:
- options: {callFromInitBoot: 'true', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '44', peripheral: FlexPWM0, signal: 'A, 0', pin_signal: P3_6/CLKOUT/LPSPI1_PCS3/PWM0_A0/FREQME_CLK_OUT1}
  - {pin_num: '43', peripheral: FlexPWM0, signal: 'B, 0', pin_signal: P3_7/TRIG_IN2/LPSPI1_PCS2/PWM0_B0}
  - {pin_num: '42', peripheral: FlexPWM0, signal: 'A, 1', pin_signal: P3_8/WUU0_IN23/TRIG_IN3/LPSPI1_SDO/LPUART1_RXD/CT_INP4/PWM0_A1/CLKOUT}
  - {pin_num: '41', peripheral: FlexPWM0, signal: 'B, 1', pin_signal: P3_9/TRIG_IN4/LPSPI1_SDI/LPUART1_TXD/CT_INP5/PWM0_B1}
  - {pin_num: '40', peripheral: FlexPWM0, signal: 'A, 2', pin_signal: P3_10/TRIG_IN5/LPSPI1_SCK/LPUART1_RTS_B/CT1_MAT0/PWM0_A2}
  - {pin_num: '39', peripheral: FlexPWM0, signal: 'B, 2', pin_signal: P3_11/WUU0_IN24/TRIG_IN6/LPSPI1_PCS0/LPUART1_CTS_B/CT1_MAT1/PWM0_B2}
  - {peripheral: FlexPWM0, signal: 'PWM_FAULT_TRG_CH, 0', pin_signal: CMP0_OUT}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitPWM
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitPWM(void)
{
    /* write to INPUTMUX0: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GateINPUTMUX0);
    /* Write to PORT3: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT3);
    /* INPUTMUX0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kINPUTMUX0_RST_SHIFT_RSTn);
    /* FLEXPWM0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kFLEXPWM0_RST_SHIFT_RSTn);
    /* PORT3 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT3_RST_SHIFT_RSTn);
    /* CMP0_OUT is selected as trigger input for FlexPWM0 FAULT channel 0 */
    INPUTMUX_AttachSignal(INPUTMUX0, 0U, kINPUTMUX_Cmp0OutToFlexPwm0Fault);

    /* PORT3_10 (pin 40) is configured as PWM0_A2 */
    PORT_SetPinMux(BOARD_INITPWM_PWM_CT_PORT, BOARD_INITPWM_PWM_CT_PIN, kPORT_MuxAlt5);

    PORT3->PCR[10] = ((PORT3->PCR[10] &
                       /* Mask bits to zero which are setting */
                       (~(PORT_PCR_IBE_MASK)))

                      /* Input Buffer Enable: Enables. */
                      | PORT_PCR_IBE(PCR_IBE_ibe1));

    /* PORT3_11 (pin 39) is configured as PWM0_B2 */
    PORT_SetPinMux(BOARD_INITPWM_PWM_CB_PORT, BOARD_INITPWM_PWM_CB_PIN, kPORT_MuxAlt5);

    PORT3->PCR[11] = ((PORT3->PCR[11] &
                       /* Mask bits to zero which are setting */
                       (~(PORT_PCR_IBE_MASK)))

                      /* Input Buffer Enable: Enables. */
                      | PORT_PCR_IBE(PCR_IBE_ibe1));

    /* PORT3_6 (pin 44) is configured as PWM0_A0 */
    PORT_SetPinMux(BOARD_INITPWM_PWM_AT_PORT, BOARD_INITPWM_PWM_AT_PIN, kPORT_MuxAlt5);

    PORT3->PCR[6] = ((PORT3->PCR[6] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_IBE_MASK)))

                     /* Input Buffer Enable: Enables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe1));

    PORT3->PCR[7] = ((PORT3->PCR[7] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_MUX_MASK | PORT_PCR_IBE_MASK)))

                     /* Pin Multiplex Control: PORT3_7 (pin 43) is configured as PWM0_B0. */
                     | PORT_PCR_MUX(PORT3_PCR7_MUX_mux101)

                     /* Input Buffer Enable: Enables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe1));

    /* PORT3_8 (pin 42) is configured as PWM0_A1 */
    PORT_SetPinMux(BOARD_INITPWM_PWM_BT_PORT, BOARD_INITPWM_PWM_BT_PIN, kPORT_MuxAlt5);

    PORT3->PCR[8] = ((PORT3->PCR[8] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_IBE_MASK)))

                     /* Input Buffer Enable: Enables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe1));

    /* PORT3_9 (pin 41) is configured as PWM0_B1 */
    PORT_SetPinMux(BOARD_INITPWM_PWM_BB_PORT, BOARD_INITPWM_PWM_BB_PIN, kPORT_MuxAlt5);

    PORT3->PCR[9] = ((PORT3->PCR[9] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_IBE_MASK)))

                     /* Input Buffer Enable: Enables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe1));
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitADC:
- options: {callFromInitBoot: 'true', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '15', peripheral: ADC0, signal: 'A, 1', pin_signal: P2_1/TRIG_IN7/LPUART0_TXD/CT_INP17/CT2_MAT1/ADC0_A1}
  - {pin_num: '17', peripheral: ADC0, signal: 'A, 2', pin_signal: P2_3/WUU0_IN19/TRIG_IN7/LPUART0_CTS_B/LPUART2_RXD/CT_INP13/CT2_MAT3/ADC0_A2/CMP1_IN0}
  - {pin_num: '63', peripheral: ADC0, signal: 'A, 21', pin_signal: P1_5/FREQME_CLK_IN1/LPSPI0_PCS2/LPUART2_TXD/CT1_MAT3/ADC0_A21/CMP1_IN2}
  - {pin_num: '62', peripheral: ADC0, signal: 'A, 20', pin_signal: P1_4/WUU0_IN8/FREQME_CLK_IN0/LPSPI0_PCS3/LPUART2_RXD/CT1_MAT2/ADC0_A20/CMP0_IN2}
  - {peripheral: ADC0, signal: 'TRG_CH, 0', pin_signal: PWM0_SM0_OUT_TRIG0}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitADC
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitADC(void)
{
    /* write to INPUTMUX0: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GateINPUTMUX0);
    /* Write to PORT1: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT1);
    /* Write to PORT2: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT2);
    /* INPUTMUX0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kINPUTMUX0_RST_SHIFT_RSTn);
    /* ADC0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kADC0_RST_SHIFT_RSTn);
    /* PORT1 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT1_RST_SHIFT_RSTn);
    /* PORT2 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT2_RST_SHIFT_RSTn);
    /* PWM0_SM0_OUT_TRIG0 is selected as trigger input for ADC0 channel 0 */
    INPUTMUX_AttachSignal(INPUTMUX0, 0U, kINPUTMUX_Pwm0Sm0OutTrig0ToAdc0Trigger);

    /* PORT1_4 (pin 62) is configured as ADC0_A20 */
    PORT_SetPinMux(BOARD_INITADC_CUR_A_PORT, BOARD_INITADC_CUR_A_PIN, kPORT_MuxAlt0);

    PORT1->PCR[4] = ((PORT1->PCR[4] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_IBE_MASK)))

                     /* Input Buffer Enable: Disables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe0));

    /* PORT1_5 (pin 63) is configured as ADC0_A21 */
    PORT_SetPinMux(BOARD_INITADC_CUR_B_PORT, BOARD_INITADC_CUR_B_PIN, kPORT_MuxAlt0);

    PORT1->PCR[5] = ((PORT1->PCR[5] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_IBE_MASK)))

                     /* Input Buffer Enable: Disables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe0));

    PORT2->PCR[1] = ((PORT2->PCR[1] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_MUX_MASK | PORT_PCR_IBE_MASK)))

                     /* Pin Multiplex Control: PORT2_1 (pin 15) is configured as ADC0_A1. */
                     | PORT_PCR_MUX(PORT2_PCR1_MUX_mux00)

                     /* Input Buffer Enable: Disables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe0));

    /* PORT2_3 (pin 17) is configured as ADC0_A2 */
    PORT_SetPinMux(BOARD_INITADC_CUR_C_PORT, BOARD_INITADC_CUR_C_PIN, kPORT_MuxAlt0);

    PORT2->PCR[3] = ((PORT2->PCR[3] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_IBE_MASK)))

                     /* Input Buffer Enable: Disables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe0));
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitENC:
- options: {callFromInitBoot: 'true', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '30', peripheral: INPUTMUX0, signal: 'TRIG_IN, 10', pin_signal: P3_31/LPTMR0_ALT2/TRIG_IN10/CT0_MAT3/ADC0_A12}
  - {peripheral: QDC0, signal: 'PHASE, A', pin_signal: TRIG_IN10}
  - {pin_num: '21', peripheral: INPUTMUX0, signal: 'TRIG_IN, 5', pin_signal: P2_7/TRIG_IN5/CT_INP19/CT1_MAT3/VREFI/ADC0_A7}
  - {peripheral: QDC0, signal: 'PHASE, B', pin_signal: TRIG_IN5}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitENC
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitENC(void)
{
    /* write to INPUTMUX0: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GateINPUTMUX0);
    /* Write to PORT2: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT2);
    /* Write to PORT3: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT3);
    /* INPUTMUX0 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kINPUTMUX0_RST_SHIFT_RSTn);
    /* PORT2 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT2_RST_SHIFT_RSTn);
    /* PORT3 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT3_RST_SHIFT_RSTn);
    /* TRIG_IN10 is selected as trigger input for QDC0 PHASEA channel 0 */
    INPUTMUX_AttachSignal(INPUTMUX0, 0U, kINPUTMUX_TrigIn10ToQdc0Phasea);
    /* TRIG_IN5 is selected as trigger input for QDC0 PHASEB channel 0 */
    INPUTMUX_AttachSignal(INPUTMUX0, 0U, kINPUTMUX_TrigIn5ToQdc0Phaseb);

    PORT2->PCR[7] = ((PORT2->PCR[7] &
                      /* Mask bits to zero which are setting */
                      (~(PORT_PCR_MUX_MASK | PORT_PCR_IBE_MASK)))

                     /* Pin Multiplex Control: PORT2_7 (pin 21) is configured as TRIG_IN5. */
                     | PORT_PCR_MUX(PORT2_PCR7_MUX_mux01)

                     /* Input Buffer Enable: Enables. */
                     | PORT_PCR_IBE(PCR_IBE_ibe1));

    PORT3->PCR[31] = ((PORT3->PCR[31] &
                       /* Mask bits to zero which are setting */
                       (~(PORT_PCR_MUX_MASK | PORT_PCR_IBE_MASK)))

                      /* Pin Multiplex Control: PORT3_31 (pin 30) is configured as TRIG_IN10. */
                      | PORT_PCR_MUX(PORT3_PCR31_MUX_mux01)

                      /* Input Buffer Enable: Enables. */
                      | PORT_PCR_IBE(PCR_IBE_ibe1));
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitCMP:
- options: {callFromInitBoot: 'true', coreID: cm33_core0, enableClock: 'true'}
- pin_list:
  - {pin_num: '16', peripheral: CMP0, signal: 'IN, 0P', pin_signal: P2_2/TRIG_IN6/LPUART0_RTS_B/LPUART2_TXD/CT_INP12/CT2_MAT2/ADC0_A4/CMP0_IN0, slew_rate: fast, pull_select: down,
    pull_enable: enable}
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitCMP
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitCMP(void)
{
    /* Write to PORT2: Peripheral clock is enabled */
    CLOCK_EnableClock(kCLOCK_GatePORT2);
    /* PORT2 peripheral is released from reset */
    RESET_ReleasePeripheralReset(kPORT2_RST_SHIFT_RSTn);

    PORT2->PCR[2] =
        ((PORT2->PCR[2] &
          /* Mask bits to zero which are setting */
          (~(PORT_PCR_PS_MASK | PORT_PCR_PE_MASK | PORT_PCR_SRE_MASK | PORT_PCR_MUX_MASK | PORT_PCR_IBE_MASK)))

         /* Pull Select: Enables internal pulldown resistor. */
         | PORT_PCR_PS(PCR_PS_ps0)

         /* Pull Enable: Enables. */
         | PORT_PCR_PE(PCR_PE_pe1)

         /* Slew Rate Enable: Fast. */
         | PORT_PCR_SRE(PCR_SRE_sre0)

         /* Pin Multiplex Control: PORT2_2 (pin 16) is configured as CMP0_IN0. */
         | PORT_PCR_MUX(PORT2_PCR2_MUX_mux00)

         /* Input Buffer Enable: Disables. */
         | PORT_PCR_IBE(PCR_IBE_ibe0));
}

/* clang-format off */
/*
 * TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
BOARD_InitINPUT_MUX:
- options: {callFromInitBoot: 'false', coreID: cm33_core0, enableClock: 'true'}
- pin_list: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS ***********
 */
/* clang-format on */

/* FUNCTION ************************************************************************************************************
 *
 * Function Name : BOARD_InitINPUT_MUX
 * Description   : Configures pin routing and optionally pin electrical features.
 *
 * END ****************************************************************************************************************/
void BOARD_InitINPUT_MUX(void)
{
}
/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
