/*
 * Copyright 2023 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*! @name PORT0_2 (number 51), P0_2/SWO/J25[3]/J18[6]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITUARTPINS_DEBUG_UART_RX_PORT PORT0               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITUARTPINS_DEBUG_UART_RX_PIN 2U                   /*!<@brief PORT pin number */
#define BOARD_INITUARTPINS_DEBUG_UART_RX_PIN_MASK (1U << 2U)      /*!<@brief PORT pin mask */
                                                                  /* @} */

/*! @name PORT0_3 (number 52), P0_3/J25[1]/J18[8]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITUARTPINS_DEBUG_UART_TX_PORT PORT0               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITUARTPINS_DEBUG_UART_TX_PIN 3U                   /*!<@brief PORT pin number */
#define BOARD_INITUARTPINS_DEBUG_UART_TX_PIN_MASK (1U << 3U)      /*!<@brief PORT pin mask */
                                                                  /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitUARTPins(void);

/*! @name PORT0_1 (number 50), P0_1/SWCLK/JP10[2]/J18[4]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDCLK_PORT PORT0               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDCLK_PIN 1U                   /*!<@brief PORT pin number */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDCLK_PIN_MASK (1U << 1U)      /*!<@brief PORT pin mask */
                                                                          /* @} */

/*! @name PORT0_0 (number 49), P0_0/SWDIO/J18[2]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PORT PORT0               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PIN 0U                   /*!<@brief PORT pin number */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_SWD_SWDIO_PIN_MASK (1U << 0U)      /*!<@brief PORT pin mask */
                                                                         /* @} */

/*! @name PORT0_2 (number 51), P0_2/SWO/J25[3]/J18[6]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_UART_RX_PORT PORT0               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_UART_RX_PIN 2U                   /*!<@brief PORT pin number */
#define BOARD_INITSWD_DEBUGPINS_DEBUG_UART_RX_PIN_MASK (1U << 2U)      /*!<@brief PORT pin mask */
                                                                       /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitSWD_DEBUGPins(void);

#define PCR_DSE_dse0 0x00u /*!<@brief Drive Strength Enable: Low */
#define PCR_IBE_ibe1 0x01u /*!<@brief Input Buffer Enable: Enables */
#define PCR_INV_inv0 0x00u /*!<@brief Invert Input: Does not invert */
#define PCR_ODE_ode0 0x00u /*!<@brief Open Drain Enable: Disables */
#define PCR_PE_pe0 0x00u   /*!<@brief Pull Enable: Disables */
#define PCR_PFE_pfe0 0x00u /*!<@brief Passive Filter Enable: Disables */
#define PCR_PS_ps0 0x00u   /*!<@brief Pull Select: Enables internal pulldown resistor */
#define PCR_SRE_sre0 0x00u /*!<@brief Slew Rate Enable: Fast */

/*! @name PORT3_13 (number 37), P3_13/J1[14]
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO GPIO3                /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO_PIN 13U              /*!<@brief GPIO pin number */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO_PIN_MASK (1U << 13U) /*!<@brief GPIO pin mask */

/* Symbols to be used with PORT driver */
#define BOARD_INITLEDSPINS_LED_GREEN_PORT PORT3                /*!<@brief PORT peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN 13U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN_MASK (1U << 13U)      /*!<@brief PORT pin mask */
                                                               /* @} */

/*! @name PORT3_12 (number 38), P3_12/J1[12]/J5[1]
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_RED_GPIO GPIO3                /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_RED_GPIO_PIN 12U              /*!<@brief GPIO pin number */
#define BOARD_INITLEDSPINS_LED_RED_GPIO_PIN_MASK (1U << 12U) /*!<@brief GPIO pin mask */

/* Symbols to be used with PORT driver */
#define BOARD_INITLEDSPINS_LED_RED_PORT PORT3                /*!<@brief PORT peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_RED_PIN 12U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_RED_PIN_MASK (1U << 12U)      /*!<@brief PORT pin mask */
                                                             /* @} */

/*! @name PORT3_0 (number 46), P3_0/J1[8]
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_BLUE_GPIO GPIO3               /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_BLUE_GPIO_PIN 0U              /*!<@brief GPIO pin number */
#define BOARD_INITLEDSPINS_LED_BLUE_GPIO_PIN_MASK (1U << 0U) /*!<@brief GPIO pin mask */

/* Symbols to be used with PORT driver */
#define BOARD_INITLEDSPINS_LED_BLUE_PORT PORT3               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN 0U                   /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN_MASK (1U << 0U)      /*!<@brief PORT pin mask */
                                                             /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitLEDsPins(void);

/*! @name PORT1_7 (number 1), P1_7/J1[1]
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITBUTTONSPINS_SW3_GPIO GPIO1               /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW3_GPIO_PIN 7U              /*!<@brief GPIO pin number */
#define BOARD_INITBUTTONSPINS_SW3_GPIO_PIN_MASK (1U << 7U) /*!<@brief GPIO pin mask */

/* Symbols to be used with PORT driver */
#define BOARD_INITBUTTONSPINS_SW3_PORT PORT1               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW3_PIN 7U                   /*!<@brief PORT pin number */
#define BOARD_INITBUTTONSPINS_SW3_PIN_MASK (1U << 7U)      /*!<@brief PORT pin mask */
                                                           /* @} */

/*! @name PORT1_29 (number 8), P1_29/J3[6]/J18[10]
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITBUTTONSPINS_SW1_GPIO GPIO1                /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW1_GPIO_PIN 29U              /*!<@brief GPIO pin number */
#define BOARD_INITBUTTONSPINS_SW1_GPIO_PIN_MASK (1U << 29U) /*!<@brief GPIO pin mask */

/* Symbols to be used with PORT driver */
#define BOARD_INITBUTTONSPINS_SW1_PORT PORT1                /*!<@brief PORT peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW1_PIN 29U                   /*!<@brief PORT pin number */
#define BOARD_INITBUTTONSPINS_SW1_PIN_MASK (1U << 29U)      /*!<@brief PORT pin mask */
                                                            /* @} */

/*! @name PORT3_29 (number 32), P3_29/J18[7]/J4[11]
  @{ */

/* Symbols to be used with GPIO driver */
#define BOARD_INITBUTTONSPINS_ISP_GPIO GPIO3                /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITBUTTONSPINS_ISP_GPIO_PIN 29U              /*!<@brief GPIO pin number */
#define BOARD_INITBUTTONSPINS_ISP_GPIO_PIN_MASK (1U << 29U) /*!<@brief GPIO pin mask */

/* Symbols to be used with PORT driver */
#define BOARD_INITBUTTONSPINS_ISP_PORT PORT3                /*!<@brief PORT peripheral base pointer */
#define BOARD_INITBUTTONSPINS_ISP_PIN 29U                   /*!<@brief PORT pin number */
#define BOARD_INITBUTTONSPINS_ISP_PIN_MASK (1U << 29U)      /*!<@brief PORT pin mask */
                                                            /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitBUTTONsPins(void);

#define PCR_IBE_ibe1 0x01u          /*!<@brief Input Buffer Enable: Enables */
#define PORT3_PCR7_MUX_mux101 0x05u /*!<@brief Pin Multiplex Control: Alternative 5 (chip-specific) */

/*! @name PORT3_6 (number 44), P3_6/J3[15]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITPWM_PWM_AT_PORT PORT3               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITPWM_PWM_AT_PIN 6U                   /*!<@brief PORT pin number */
#define BOARD_INITPWM_PWM_AT_PIN_MASK (1U << 6U)      /*!<@brief PORT pin mask */
                                                      /* @} */

/*! @name PORT3_7 (number 43), P3_7/J3[13]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITPWM_PWM_AB_PORT PORT3               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITPWM_PWM_AB_PIN 7U                   /*!<@brief PORT pin number */
#define BOARD_INITPWM_PWM_AB_PIN_MASK (1U << 7U)      /*!<@brief PORT pin mask */
                                                      /* @} */

/*! @name PORT3_8 (number 42), P3_8/J3[11]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITPWM_PWM_BT_PORT PORT3               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITPWM_PWM_BT_PIN 8U                   /*!<@brief PORT pin number */
#define BOARD_INITPWM_PWM_BT_PIN_MASK (1U << 8U)      /*!<@brief PORT pin mask */
                                                      /* @} */

/*! @name PORT3_9 (number 41), P3_9/J3[9]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITPWM_PWM_BB_PORT PORT3               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITPWM_PWM_BB_PIN 9U                   /*!<@brief PORT pin number */
#define BOARD_INITPWM_PWM_BB_PIN_MASK (1U << 9U)      /*!<@brief PORT pin mask */
                                                      /* @} */

/*! @name PORT3_10 (number 40), P3_10/J3[7]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITPWM_PWM_CT_PORT PORT3                /*!<@brief PORT peripheral base pointer */
#define BOARD_INITPWM_PWM_CT_PIN 10U                   /*!<@brief PORT pin number */
#define BOARD_INITPWM_PWM_CT_PIN_MASK (1U << 10U)      /*!<@brief PORT pin mask */
                                                       /* @} */

/*! @name PORT3_11 (number 39), P3_11/J3[5]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITPWM_PWM_CB_PORT PORT3                /*!<@brief PORT peripheral base pointer */
#define BOARD_INITPWM_PWM_CB_PIN 11U                   /*!<@brief PORT pin number */
#define BOARD_INITPWM_PWM_CB_PIN_MASK (1U << 11U)      /*!<@brief PORT pin mask */
                                                       /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPWM(void);

#define PCR_IBE_ibe0 0x00u         /*!<@brief Input Buffer Enable: Disables */
#define PORT2_PCR1_MUX_mux00 0x00u /*!<@brief Pin Multiplex Control: Alternative 0 (GPIO) */

/*! @name PORT2_1 (number 15), P2_1/J2[7]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITADC_VOLT_DCB_PORT PORT2               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITADC_VOLT_DCB_PIN 1U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_VOLT_DCB_PIN_MASK (1U << 1U)      /*!<@brief PORT pin mask */
                                                        /* @} */

/*! @name PORT2_3 (number 17), P2_3/J2[5]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITADC_CUR_C_PORT PORT2               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITADC_CUR_C_PIN 3U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_CUR_C_PIN_MASK (1U << 3U)      /*!<@brief PORT pin mask */
                                                     /* @} */

/*! @name PORT1_5 (number 63), P1_5/J2[3]/J1[4]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITADC_CUR_B_PORT PORT1               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITADC_CUR_B_PIN 5U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_CUR_B_PIN_MASK (1U << 5U)      /*!<@brief PORT pin mask */
                                                     /* @} */

/*! @name PORT1_4 (number 62), P1_4/J2[1]/J1[2]
  @{ */

/* Symbols to be used with PORT driver */
#define BOARD_INITADC_CUR_A_PORT PORT1               /*!<@brief PORT peripheral base pointer */
#define BOARD_INITADC_CUR_A_PIN 4U                   /*!<@brief PORT pin number */
#define BOARD_INITADC_CUR_A_PIN_MASK (1U << 4U)      /*!<@brief PORT pin mask */
                                                     /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitADC(void);

#define PCR_IBE_ibe1 0x01u          /*!<@brief Input Buffer Enable: Enables */
#define PORT2_PCR7_MUX_mux01 0x01u  /*!<@brief Pin Multiplex Control: Alternative 1 (chip-specific) */
#define PORT3_PCR31_MUX_mux01 0x01u /*!<@brief Pin Multiplex Control: Alternative 1 (chip-specific) */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitENC(void);

#define PCR_IBE_ibe0 0x00u         /*!<@brief Input Buffer Enable: Disables */
#define PCR_PE_pe1 0x01u           /*!<@brief Pull Enable: Enables */
#define PCR_PS_ps0 0x00u           /*!<@brief Pull Select: Enables internal pulldown resistor */
#define PCR_SRE_sre0 0x00u         /*!<@brief Slew Rate Enable: Fast */
#define PORT2_PCR2_MUX_mux00 0x00u /*!<@brief Pin Multiplex Control: Alternative 0 (GPIO) */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitCMP(void);

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitINPUT_MUX(void);

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
